#include <bits/stdc++.h>
#define x first
#define y second
#define mp make_pair

using namespace std;

typedef long long ll;
typedef pair < double, double > pdd;

vector < double > X, Y;
// vector < pair < double, ll > > event(201);
pair < double, ll > event [201];

bool cmp(pair < double, ll > a, pair < double, ll > b)
{
    return (a.x < b.x);
}

int main()
{
    freopen("circle.in", "r", stdin);
    freopen("circle.out", "w", stdout);

    ll n, k;
    cin >> n >> k;
    for (ll i = 0; i < n; ++i)
    {
        double x0, y0;
        cin >> x0 >> y0;
        X.push_back(x0);
        Y.push_back(y0);
    }
    double lowerR = 0.0, upperR = 20000.0;
    if (k == 1)
    {
        cout << "0.000" << '\n';
        return 0;
    }
    for (ll iter = 0; iter < 40; ++iter)
    {
        ll mx = 0;
        double R = (lowerR + upperR) / 2.0;
        for (ll i = 0; i < n; ++i)
        {
            ll c = 1, it = 0;
            for (ll j = 0; j < n; ++j) if (j != i)
            {
                double D = hypot(X [i] - X [j], Y [i] - Y [j]);
                if (2 * R < D) continue;
                double d = D / 2.0;
                double H = sqrt(R * R - d * d);
                pdd _norm = mp((X [i] - X [j]) / D, (Y [i] - Y [j]) / D);
                pdd f = mp(d * _norm.x + H * _norm.y, d * _norm.y - H * _norm.x), s(d * _norm.x - H * _norm.y, d * _norm.y + H * _norm.x);
                double alpha = atan2(f.y, f.x), beta = atan2(s.y, s.x);
                if (alpha > beta) ++c;
                event [it] = mp(alpha, 1); ++it;
                event [it] = mp(beta, - 1); ++it;
            }
            sort(event, event + it, cmp);
            for (ll j = 0; j < it; ++j)
            {
                c += event [j].y;
                mx = max(mx, c);
            }
        }
        if (mx >= k) upperR = R;
        else lowerR = R;
    }
    double ans = (upperR + lowerR) / 2.0;
    printf("%0.3lf\n", ans);
}
