#include<bits/stdc++.h>

using namespace std;

const double pi = 3.1415926535;
struct point {
    double x, y;
    point(double x, double y) : x(x), y(y) {}
    point() {}
};
point operator-(point a, point b) {
    return point(a.x - b.x, a.y - b.y);
}

double abs(point a) {
    return sqrt(a.x * a.x + a.y * a.y);
}

point arr[201];

pair<double, int> angle[402];
int sz = 0;

int main() {
    freopen("circle.in", "r", stdin);
    freopen("circle.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;
    cin >> n >> k;
    for(int i = 0;i < n;++i)
        cin >> arr[i].x >> arr[i].y;
    double l = 0, r = 2000, m,
        d, s, ang1, ang2;

    int tmp, cur;
    point seg;
    while(r - l > 1e-4) {
        m = (l + r) / 2;
        for(int i = 0;i < n;++i) {
            tmp = 1;
            sz = 0;
            for(int j = 0;j < n;++j) {
                if(i == j)
                    continue;
                seg = arr[j] - arr[i];
                d = abs(seg);
                if(m < d / 2.0)
                    continue;
                s = sqrt(m * m - d * d / 4.0);
                ang1 = atan2(s, d/2.0);
                ang2 = atan2(seg.y, seg.x);
                if(ang2 - ang1 < -pi) {
                    angle[sz++] = make_pair(ang2 - ang1 + 2*pi, -1);
                    tmp++;
                }
                else
                    angle[sz++] = make_pair(ang2 - ang1, -1);
                if(ang2 + ang1 >= pi) {
                    angle[sz++] = make_pair(ang2 + ang1 - 2*pi, 1);
                    tmp++;
                }
                else
                    angle[sz++] = make_pair(ang2 + ang1, 1);
            }
            sort(angle, angle + sz);
            cur = tmp;
            for(int i = 0;i < sz;++i) {
                tmp -= angle[i].second;
                cur = max(cur, tmp);
            }
            if(cur >= k)
                break;
        }
        if(cur >= k)
            r = m;
        else
            l = m;
    }
    cout << setprecision(3) << fixed << (l + r)/2.0 << '\n';
    return 0;
}
