/* GCC */
#include <bits/stdc++.h>

using namespace std;

#define MAX_R 1000
#define LOOPS_TIME 25
#define PI acos(-1)

struct xy{
    double x, y;
};

vector<xy> dots;

int main(){
freopen("circle.in", "r", stdin);
freopen("circle.out", "w", stdout);
    int n, k, c;
    scanf("%d %d", &n, &k);
    dots.resize(n);
    for (int i = 0; i < n; i++){
        scanf("%lf %lf", &dots[i].x, &dots[i].y);
    }
    int best;
    double r1 = 0, r2 = MAX_R;
    double l, h, phi, betta, alpha1, alpha2;
    vector<pair<double, int> > line;
    for (int loops = 0; loops < LOOPS_TIME; loops++){
        best = 1;
        double r = (r1+r2)/2;
        for (int i = 0; i < n; i++){
            c = 1;
            line.clear();
            for (int z = 0; z < n; z++){
                if (i == z) continue;
                l = hypot(dots[i].x-dots[z].x, dots[i].y-dots[z].y);
                if (l/2 > r) continue;
                h = dots[z].y-dots[i].y;
                betta = PI/2-asin(l/(2*r));
                if (dots[z].x > dots[i].x){
                    phi = asin(h/l);
                } else {
                    phi = PI-asin(h/l);
                }
                alpha1 = phi-betta;
                alpha2 = phi+betta;
                line.push_back(make_pair(alpha1, 1));
                line.push_back(make_pair(alpha2, -1));
            }
            sort(line.begin(), line.end());
            for (int j = 0; j < (int)line.size(); j++){
                c += line[j].second;
                best = max(best, c);
            }
        }
        if (best < k){ r1 = r;}
        else {r2 = r;}
    }
    printf("%.3lf\n", (r1+r2)/2);
}






































