/* GCC */
#include<algorithm>
#include<iostream>
#include<iomanip>
#include<cstdio>
#include<cmath>
#define point pair<double, double>
#define x first
#define y second

using namespace std;

const int N = 200+1, prec = 27;

int n, k, res, c;
point a[N];
double rl, rr, r, d, l1, l2, alpha, norm_x, norm_y, angle_1, angle_2;
point p1, p2;
int cnt;
pair<double, int> ev[2*N];

int main(){
    freopen("circle.in", "r", stdin);
    freopen("circle.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    cout << fixed << setprecision(3);
    cin >> n >> k;
    for(int i = 0; i < n; ++i)
        cin >> a[i].x >> a[i].y;
    rl = 0, rr = 2000;
    for(int _ = 0; _ < prec; ++_){
        r = (rl+rr)/2;
        res = 0;
        for(int i = 0; i < n; ++i){
            c = 1;
            cnt = 0;
            for(int j = 0; j < n; ++j){
                if(i == j)
                    continue;
                d = hypot(a[j].x - a[i].x, a[j].y - a[i].y);
                l1 = d/2;
                if(l1 > r)
                    continue;
                l2 = sqrt(r*r - l1*l1);
                alpha = atan2(a[j].y - a[i].y, a[j].x - a[i].x);
                norm_x = cos(alpha);
                norm_y = sin(alpha);
                p1 = point(l1 * norm_x + l2 * norm_y, l1 * norm_y - l2 * norm_x);
                p2 = point(l1 * norm_x - l2 * norm_y, l1 * norm_y + l2 * norm_x);
                angle_1 = atan2(p1.y, p1.x);
                angle_2 = atan2(p2.y, p2.x);
                if(angle_1 > angle_2)
                    ++c;
                ev[cnt++] = make_pair(angle_1, 1);
                ev[cnt++] = make_pair(angle_2, -1);
            }
            sort(ev, ev + cnt);
            res = max(res, c);
            for(int i = 0; i < cnt; ++i){
                c += ev[i].second;
                res = max(res, c);
            }
        }
        if(res >= k)
            rr = r;
        else
            rl = r;
    }
    cout << (rl+rr)/2 << endl;
}
